﻿using System;
using System.IO;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.Caching;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Infragistics.WebUI.UltraWebGrid;
using Infragistics.WebUI.UltraWebCalcManager;
using Infragistics.WebUI.WebDataInput;

namespace CalcManagerIssue
{
    public partial class Default1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void ugQryResults_InitializeLayout(object sender, LayoutEventArgs e)
        {
            int iCol = 0;
            DataTable dtColumns = new DataTable();
            Infragistics.WebUI.UltraWebGrid.UltraGridColumn c = ugQryResults.DisplayLayout.Bands[0].Columns[iCol];
            c.Header.Caption = "Company";
            dtColumns = GetData.getGroupFields();
            c.Footer.Caption = "AVG";

            foreach (DataRow dr in dtColumns.Rows)
            {
                iCol++;
                int iDec = Convert.ToInt32(dr["Decimals"]);
                c = ugQryResults.DisplayLayout.Bands[0].Columns[iCol];
                c.Header.Key = dr["Text"].ToString();
                c.Header.Caption = dr["Text"].ToString();
                switch (dr["DataType"].ToString())
                {
                    case "N":
                        String sFormat = "###,###,##0";
                        if (iDec > 0)
                        {
                            sFormat += ".";
                            for (int i = 1; i <= iDec; i++)
                            {
                                sFormat += "0";
                            }
                        }
                        c.DataType = "System.Double";
                        c.Format = sFormat;
                        c.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                        if (dr["Total"].ToString() == "1")
                        {
                            c.Footer.Key = dr["Text"].ToString() + "_Total";
                            c.Footer.Total = SummaryInfo.Avg;
                            c.Footer.Formula = "ROUND(AVG([" + dr["Text"].ToString() + "])," + iDec.ToString() + ")";
                        }
                        break;
                    case "Y":
                        c.DataType = "System.Double";
                        c.Format = "0000.0";
                        c.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                        break;
                    case "T":
                        c.DataType = "System.String";
                        break;
                }
            }

            ugQryResults.Bands[0].ColFootersVisible = ShowMarginInfo.Yes;
        }

        protected void ugQryResults_InitializeRow(object sender, Infragistics.WebUI.UltraWebGrid.RowEventArgs e)
        {
        }

        protected void ugQryResults_DataBinding(object sender, System.EventArgs e)
        {
            string s1stCol = "";
            string sConst = "";
            DataTable dtRows = new DataTable();
            DataTable dtColumns = new DataTable();
            DataTable dtValues = new DataTable();

            dtRows = GetData.getGroupCompanies();
            dtColumns = GetData.getGroupFields();
            s1stCol = "Company";
            sConst = "2006.4";

            dtValues.Columns.Add(s1stCol);
            foreach (DataRow drCol in dtColumns.Rows)
            {
                dtValues.Columns.Add(drCol["text"].ToString());
            }

            String sCompCode = "";
            int iDataPoint = 0;
            double nPeriod = 0.0;
            foreach (DataRow drRow in dtRows.Rows)
            {
                DataRow row = dtValues.NewRow();
                int iDecmls = Convert.ToInt32(drRow["Decimals"]);
                switch (drRow["DataType"].ToString())
                {
                    case "N":
                        row[s1stCol] = Math.Round(Convert.ToDouble(drRow["Text"]), iDecmls);
                        break;
                    case "Y":
                        row[s1stCol] = Math.Round(Convert.ToDouble(drRow["Text"]), iDecmls);
                        break;
                    case "T":
                        row[s1stCol] = drRow["Text"].ToString();
                        break;
                }
                foreach (DataRow drCol in dtColumns.Rows)
                {
                    sCompCode = drRow["Value"].ToString();
                    iDataPoint = Convert.ToInt32(drCol["Value"]);
                    nPeriod = Convert.ToDouble(sConst);

                    //String sVal = sCompCode + "," + iDataPoint.ToString() + "," + nPeriod.ToString();
                    //String sVal = GetData.GetDataPointData_old(sCompCode, iDataPoint, nPeriod);
                    DataTable dtDPData = GetData.GetDataPointData(sCompCode, iDataPoint, nPeriod);
                    DataRow drDPData = dtDPData.Rows[0];
                    String sType = drDPData["Type"].ToString();
                    String sVal = drDPData["Value"].ToString();
                    iDecmls = Convert.ToInt32(drCol["Decimals"]);

                    //if (sVal == "" || sVal == "#Err")
                    //{
                    //    row[drCol["Text"].ToString()] = sVal;
                    //}
                    if (sType == "C")
                    {
                        CalcSettings objCalcSettings = null;
                        objCalcSettings = UltraWebCalcManager1.GetCalcSettings(txtFormula);
                        objCalcSettings.PropertyName = "Value";
                        objCalcSettings.Formula = sVal;
                        row[drCol["Text"].ToString()] = txtFormula.Value.ToString();
                    }
                    else
                    {
                        switch (drCol["DataType"].ToString())
                        {
                            case "N":
                                row[drCol["Text"].ToString()] = Math.Round(Convert.ToDouble(sVal), iDecmls);
                                break;
                            case "Y":
                                row[drCol["Text"].ToString()] = Math.Round(Convert.ToDouble(sVal), iDecmls);
                                break;
                            case "T":
                                row[drCol["Text"].ToString()] = sVal;
                                break;
                        }
                    }
                }
                dtValues.Rows.Add(row);
            }

            ugQryResults.DataSource = dtValues;
        }

        protected void warpQryResults_ContentRefresh(object sender, EventArgs e)
        {
            ugQryResults.DataBind();
        }
    }
}
