﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using System.Configuration;
using System.Web.Security;

namespace CalcManagerIssue
{
    public class GetData
    {
        public static DataTable getGroupFields()
        {
            DataTable ret = new DataTable();

            ret.Columns.Add("Text", typeof(String));
            ret.Columns.Add("Value", typeof(int));
            ret.Columns.Add("DataType", typeof(String));
            ret.Columns.Add("Decimals", typeof(int));
            ret.Columns.Add("Total", typeof(int));

            DataRow row = ret.NewRow();
            row["Text"] = "CalcField";
            row["Value"] = 99900001;
            row["DataType"] = "N";
            row["Decimals"] = 2;
            row["Total"] = 1;

            ret.Rows.Add(row);

            return ret;
        }

        public static DataTable getGroupCompanies()
        {
            DataTable ret = new DataTable();

            ret.Columns.Add("Text", typeof(String));
            ret.Columns.Add("Value", typeof(String));
            ret.Columns.Add("DataType", typeof(String));
            ret.Columns.Add("Decimals", typeof(int));

            DataRow row = ret.NewRow();
            row["Text"] = "Company1";
            row["Value"] = "PCC001";
            row["DataType"] = "T";
            row["Decimals"] = 0;

            ret.Rows.Add(row);

            row = ret.NewRow();
            row["Text"] = "Company2";
            row["Value"] = "PCC002";
            row["DataType"] = "T";
            row["Decimals"] = 0;

            ret.Rows.Add(row);

            return ret;
        }

        public static DataTable GetDataPointData(String sCompCode, int iDataPoint, double nPeriod)
        {
            DataTable ret = new DataTable();

            ret.Columns.Add("Type", typeof(String));
            ret.Columns.Add("Value", typeof(String));

            DataRow row = ret.NewRow();
            row["Type"] = "C";
            row["Value"] = GetCalcedData("{Field1[*]}/{Field2[*]}*100", sCompCode, nPeriod);

            ret.Rows.Add(row);

            return ret;
        }

        public static String GetCalcedData(String sFormula, String sCompCode, double nPeriod)
        {
            String ret = "";
            string sOrigFormula = sFormula;
            double nFldPeriod = nPeriod;

            int iOpen = 0;
            int iClose = -1;
            int iStart = iClose + 1;
            while (iStart > -1)
            {
                iOpen = sOrigFormula.IndexOf("{");
                if (iOpen == -1) break;
                iClose = sOrigFormula.IndexOf("}", iOpen + 1);
                iStart = iClose;
                string sFieldPeriod = sOrigFormula.Substring(iOpen + 1, iClose - iOpen - 1);
                int iPOpen = sFieldPeriod.IndexOf("[");
                int iPClose = sFieldPeriod.IndexOf("]");
                string sField = sFieldPeriod.Substring(0, iPOpen);
                string sPeriod = sFieldPeriod.Substring(iPOpen + 1, iPClose - iPOpen - 1);
                if (sPeriod != "*") nFldPeriod = Convert.ToDouble(sPeriod);
                string sFldDP = GetFieldData(sCompCode, nFldPeriod, sField);
                sOrigFormula = sOrigFormula.Replace("{" + sFieldPeriod + "}", sFldDP);
            }

            ret = sOrigFormula;

            return ret;
        }

        public static String GetFieldData(String sCompCode, double nPeriod, String sFldName)
        {
            String ret = "";

            switch (sCompCode)
            {
                case "PCC001":
                    ret = (sFldName=="Field1") ? "344085" : "541315";
                    break;
                case "PCC002":
                    ret = (sFldName == "Field1") ? "34408" : "58819";
                    break;
            }

            return ret;
        }
    }
}
